<?php
/* Copyright start
  Copyright (C) 2008 - 2024 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Constants;


class AppConstants
{

    public const TEAM_IRI = '/api/3/teams';
    public const DEFAULT_MAX_REL_COUNT = 100;
    public const NORMALIZER_METHOD = 'jsonld';
    public const BATCH_SIZE_FOR_BULK = 30;
    public const WORKFLOW_EXECUTION_KEY = 'cyops.workflow.execute';
    public const FILE_IRI = "/api/3/files/";
    public const PICKLIST_IRI = "/api/3/picklists/";
    public const CONTENTHUB_URL = "/content-hub/";
    public const CONTENTHUB_METADATA_JSON = "content-hub.json";

    public const DEFALUT_KEY = 'cyops.crudhub.datanotify';
    public const STATUS = array(
        "DRAFT" => "Draft",
        "GENERATING_OPTIONS" => "Generating Options",
        "OPTIONS_GENERATED" => "Reviewing",
        "IMPORTING" => "In Progress",
        "PUBLISHING" => "Publishing Modules",
        "ERROR" => "Error",
        "IMPORT_COMPLETE" => "Import Complete"
    );
    public const CONFIG_TYPES = array(
        "picklistNames" => "fsr.core.service.picklist_name_config",
        "modules" => "fsr.core.service.module_config",
        "viewTemplates" => "fsr.core.service.view_config",
        "views" => "fsr.core.service.view_config",
        "roles" => "fsr.core.service.role_config",
        "actors" => "fsr.core.service.actor_config",
        "teams" => "fsr.core.service.team_config",
        "playbooks" => "fsr.core.service.playbook_config",
        "playbookBlocks" => "fsr.core.service.playbook_block_config",
        "rules" => "fsr.core.service.rule_config",
        "ruleChannels" => "fsr.core.service.rule_config",
        "reports" => "fsr.core.service.report_config",
        "dashboards" => "fsr.core.service.dashboard_config",
        "connectors" => "fsr.core.service.connector_config",
        "widgets" => "fsr.core.service.widget_config",
        "recordSets" => "fsr.core.service.record_set_config",
        "appSettings" => "fsr.core.service.app_settings_config",
        "preprocessingRules" => "fsr.core.service.preprocessing_rule_config",
        "exportTemplates" => "fsr.core.service.export_template_config",
    );
    public const TRAITS_ATTRIBUTES = ['id', 'createDate', 'modifyDate', 'createUser', 'modifyUser', 'sattrib', 'importedBy', 'lastModifyDate'];
    public const STIX_TRAITS_ATTRIBUTES = ['createDate', 'modifyDate', 'createUser', 'modifyUser', 'sattrib', 'importedBy', 'lastModifyDate'];
    public const INVALID_CHAR_IN_TAG = "Special characters '#', '?', ',', '\'', '\"' and '/' are not allowed in tag.";

    public const DELTA_DATA = 'data';
    public const HTTP_METHOD = 'operation';
    public const REMOTE_ADDR = 'source';
    public const WEB_SOCKET_SESSION_ID = 'websocketId';
    public const COMPONENT = 'component';
    public const ENTITY_TYPE = 'entityType';
    public const OPERATION = 'operation';
    public const USER_UUID = 'userId';
    public const USER = 'user';
    public const TRANSACTION_DATE = 'transactionDate';
    public const DEFAULT_KEY = 'cyops.crudhub.datanotify';
    public const ENTITY_UUID = 'entityUuid';
    public const ELASTIC_SEARCH_OPERATION_KEY = 'esoperation';
    public const SOLUTIONPACK_TYPE = 'solutionpack';
    public const MULTICONTENT_TYPE = 'multiContent';
    public const TMP_SAFE_PATH = '/tmp/';
    public const MIN_TAG_LENGTH = 2;
    public const FILE_NAME_CLEANUP_REGEX = '/[\*\/\\\?\<\>\:\"\'\|]/';
    public const CRUDHUB_PARAMETER_KEY = 'crudhub.uri';
    public const REQUIRED_MIN_SPACE_PUBLISH = 100; //100MB
    public const BYTES_TO_MB_DENOMINATOR = 1048576; //1024*1024
    public const FSR_MIN_COMPATIBILITY = 'fsrMinCompatibility';
    public const COMPATIBILITY = 'compatibility';

    public const METHOD_MAP = [
        "post" => "create",
        "put" => "update",
        "delete" => "delete"
    ];
    public const TOTAL_RESTRICTED_FEEDS_COUNT = 100;
    public const TOTAL_INGESTION_FEEDS_LIMIT = 1000;
    public const TOTAL_RESTRICTED_COLLECTIONS_COUNT = 3;
    public const TOTAL_RESTRICTED_FEEDS_PAGE = 1;
    public const MASTER_ROLE_NAME = 'master';
    public const FEED_COUNT = 'feed_count';

    public const LATEST_FEED_QUERY = "SELECT createdate from ";
    public const ACTION = 'action';
    public const METHOD = 'method';
    public const PLAYBOOK_IRI = 'playbookIri';
    public const PLAYBOOK_NAME = 'playbookName';
    public const TITLE = 'title';

    public const PUBLISH_IGNORE_ATTRIBUTES = ['importedBy', 'orderIndex', 'gridColumn', 'bulkAction', 'tooltip', 'visibility', 'recommend', 'dataSourceFilters', 'identifier', 'readable', 'system', 'searchable', 'htmlEscape', 'defaultValue'];
    public const CUSTOM_DATE_DEFAULT_VALUE_IDENTIFIER = '%22differenceType%22';

    public const IGNORE_TAG_FOR_SUGGESTION = 'excludefromsuggestion';
    public const WORKFLOW_STEP_TYPES_IRI_MAP = [
        "WorkflowReference" => "/api/3/workflow_step_types/74932bdc-b8b6-4d24-88c4-1a4dfbc524f3"
    ];
    public const CACHE_EXPIRY_FOR_LICENSE = 7200;
    public const IGNORE_MISSING_RELATIONSHIP = '$ignore_missing_relations';
    public const CUSTOM_MODULE_IDENTIFIER = 'App\Entity\Custom';

    # Indicating request for record is directly invoked on current node.
    public const SOURCE_ORIGIN = 'origin';

    # Indicating request for record is invoked by replication service on current node
    public const SOURCE_REPLICATE = 'replicate';

    # Flag is used to indicate that record is coming in system as part of replication invoked by replication service.
    public const IS_REPLICATION_FLAG = 'isReplication';

    public const WIDGET_ALLOWED_FILE_EXTENSIONS = ['js', 'html', 'css', 'json', 'txt', 'ttf', 'svg'];

    public const VALUE = "value";
    public const FIELD = "field";
    public const PICKLIST_CLASS = "App\Entity\Core\Picklist";
    public const PICKLIST_NAME = 'picklistName';
    public const PICKLIST_VALUE = "picklistValue";

    public const HTTP_GET = 'GET';

    public const SECONDS_IN_ONE_DAY = 86400;

    public const APP_PROXY_CLIENT_WORKFLOW = "app.proxy.client.workflow";
    public const RULE_URI = 'rule.uri';

    public const SYSTEM_ENTITY = [
        'App\Entity\Actors\Actor', 'App\Entity\Actors\Avatar', 'App\Entity\Authorization\FieldPermission',
        'App\Entity\Authorization\ModulePermission', 'App\Entity\Authorization\Role', 'App\Entity\Authorization\Team',
        'App\Entity\Core\AbstractFile', 'App\Entity\Core\EmailTemplate', 'App\Entity\Core\ExportJob',
        'App\Entity\Core\ExportTemplate', 'App\Entity\ActionSuggestion\Statistic', 'App\Entity\Core\File',
        'App\Entity\Core\Image', 'App\Entity\Core\ImportJob', 'App\Entity\Core\Module',
        'App\Entity\Core\PgFile', 'App\Entity\Core\Picklist', 'App\Entity\Core\PicklistName',
        'App\Entity\Core\Proxy', 'App\Entity\Core\Tag', 'App\Entity\Core\Widget',
        'App\Entity\Core\SolutionPack', 'App\Entity\Core\Picklist', 'App\Entity\ModelMetadata\AttribModelMetadata',
        'App\Entity\ModelMetadata\AttributeMetadata', 'App\Entity\ModelMetadata\ModelMetadata',
        'App\Entity\ModelMetadata\StagingModelMetadata', 'App\Entity\ModelMetadata\ClusterCommand',
        'App\Entity\Query\Query', 'App\Entity\Query\UserQuery', 'App\Entity\Query\SystemQuery',
        'App\Entity\Settings\Settings', 'App\Entity\Settings\SystemSettings', 'App\Entity\Settings\UserSettings',
        'App\Entity\ViewTemplate\GenericTemplate', 'App\Entity\ViewTemplate\Reporting',
        'App\Entity\ViewTemplate\Dashboard', 'App\Entity\ViewTemplate\UserDefaultTemplate',
        'App\Entity\ViewTemplate\UserPreference', 'App\Entity\ViewTemplate\UserViewTemplate',
        'App\Entity\ViewTemplate\SystemViewTemplate', 'App\Entity\Workflow\Workflow',
        'App\Entity\Workflow\WorkflowCollection', 'App\Entity\Workflow\WorkflowCollection',
        'App\Entity\Workflow\Workflow', 'App\Entity\Workflow\WorkflowVersion', 'App\Entity\Workflow\WorkflowStep',
        'App\Entity\Workflow\WorkflowRoute', 'App\Entity\Workflow\WorkflowGroup', 'App\Entity\Workflow\WorkflowStepType',
        'App\Entity\Base\FilterableEntity', 'App\Entity\Core\File', 'App\Entity\Actors\Actor',
        'App\Entity\ThreatIntel\ThreatIntelBase', 'App\Entity\Core\ConfigProp', 'App\Entity\Workflow\StepTypeCollection',
        'App\Entity\Rules\PreprocessingRule'
    ];

    //Entity Attribute Map key
    public const  ENTITY_ATTR_MAP_PICKLIST = "picklist";
    public const ENTITY_ATTR_MAP_RELATED_FIELDS = "relatedFields";
    public const ENTITY_ATTR_MAP_ATTRIBUTES = "attributeFormType";
    public const AUDIT_PRODUCER = "old_sound_rabbit_mq.cyops_crud_auditing_producer";
    public const CONTENT_TYPE_JSON = 'application/json';
    public const RULE_ACTION_DROP = "drop";
    public const RULE_ACTION_UPDATE = "update";
    public const CRUD_HUB = "crudhub";
    public const RULE_MAX_DAYS_FILTER_KEY = "preprocessing_rule_max_days_filter";
    public const RULE_MAX_DAYS_FILTER_DEFAULT_VALUE = 3;
    public const QUERY_FILTER_TYPE = "type";
    public const QUERY_FILTER_FIELD = "field";
    public const QUERY_FILTER_VAL = "value";
    public const QUERY_FILTER_OPERATOR = "operator";
    public const QUERY_FILTER__OPERATOR = "_operator";
    public const FILTER_TYPE_PRIMITIVE = "primitive";
    public const SKIP_PLAYBOOK_EXECUTION = 'SKIP_PLAYBOOK_EXECUTION';
    public const RULE_DETAILS = "RULE";
    public const AUDIT_OPERATION_DROP = "Pre-Processing(Drop)";
    public const AUDIT_OPERATION_UPDATE = "Pre-Processing(Update)";
    public const AUDIT_OPERATION_RULE_FAILED = "Pre-Processing(Fail)";
    public const RECORD_TYPE_EXISTING = "existing";
    public const RECORD_TYPE_INCOMING = "incoming";
    public const CACHE_EXPIRY_FOR_API_KEY = 3600;
    public const HUMAN_READABLE_DATE_FORMAT = 'Y-m-d\TH:i:s\Z';

    // Language support directory
    public const UI_LOCALES_PATH = '/opt/cyops-ui/locales';
    public const LOCALES_MMD_PATH = '/opt/cyops/configs/cyops-ui/locales/mmd';
    public const ATTR_FSR_SUB_REQUEST_TYPE = 'fsr_subrequest_type';
    public const ATTR_FSR_PREVIOUS_DATA = 'fsr_previous_data';
    public const FSR_SUB_REQUEST_IMPORT = 'import';
    public const NORMALIZER_RELATIONSHIPS = 'relationships';
    public const NORMALIZER_EXPORT = 'export';
    public const NORMALIZER_AS_JSON = 'asJson';
    public const NORMALIZER_ARCHIVED = 'archived';
    public const NORMALIZER_FSR_MAX_RELATIONSHIP_COUNT = 'fsr_max_relation_count';
    public const NORMALIZER_SHOW_PASSWORD = 'showPassword';
    public const NORMALIZER_HIDE_UUID = 'hideUuid';
    public const NORMALIZER_DISPLAY_NAME_ONLY = 'displayNameOnly';
    public const NORMALIZER_CSV_NEUTRALIZATION = 'csvNeutralization';
    public const NORMALIZER_HUMAN_READABLE_DATE_FORMAT = 'humanReadableDateFormat';
    public const ENTITY_PREPROCESSING_RULES = "preprocessing_rules";
    public const CONFIG_MAX_RESPONSE_REL_COUNT = 'response_max_relation_count';
    public const CONFIG_MAX_AUDIT_REL_COUNT = "max_relation_count";
    public const REQUEST_MAX_RESPONSE_REL_COUNT = '$fsr_max_relation_count';
    public const PARAM_CONTENT_HUB_REQ_CHUNK_SIZE = "content_hub_request_chunk_size";
    public const DEFAULT_CONTENT_HUB_CHUNK_SIZE = 100;
    public const MAX_ITEM_TO_BE_DELETED_FOR_SQL_DELETE = 60000;
    // Picklists
    public const PICKLISTS = array(
        "CONFIGURATION_STATUS" => array(
            "CONFIGURED" => "/api/3/picklists/e89a4393-98b4-4d62-8083-a652b6a4a2d7",
            "NOT_CONFIGURED" => "/api/3/picklists/29395624-0300-46a5-90b3-a6af4c5154d9",
            "CONFIGURATION_FAILED" => "/api/3/picklists/29395624-0300-46a5-90b3-a6af4c5154d9"
        )
    );
}

