<?php
/* Copyright start
  Copyright (C) 2008 - 2024 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Constants;


class ErrorConstants
{
    public const TAXII_SERVER_DISABLED = 'TAXII Server is currently disabled, contact system admin to enable it';
    public const DEPENDENCY_FAILED = 'Cannot proceed as installation of dependent solution pack[s] failed';
    public const CUSTOM_DEPENDENCY_FAILED = 'Cannot proceed as a custom dependent solution pack is not installed. Please install the dependent solution pack manually and try again';

    // Advance Query Controller -> queryAssociationAction
    public const FIELD_MISSING = 'There is no field: %s in the resource class %s';

    // Agent Controller
    public const AGENT_ID_EXISTS = "AgentId: %s already exists, use different AgentId";
    public const AGENT_NAME_EXISTS = "Agent Name: %s already exists, use different Agent Name";
    public const INVALID_CLIENT_CERT = 'Invalid client certificate. The extended key usage attribute in certificate must have the client authentication.';
    public const SELF_AGENT_ADD_DETECTED = 'Self Agent cannot be added';
    public const DB_PASSWORD_DECRYPT_FAILED = 'DB Password decrypt failed with error: %s';

    //Bulk Create Controller
    public const RESOURCE_DOES_NOT_MATCH = 'The resource in the record IRIs does not match the resource in API route';

    // Comment Controller
    public const COMMENT_MODIFICATION_BLOCKED = 'Modification of comments has been blocked by your administrator.';
    public const MESSAGE_MODIFICATION_NOT_ALLOWED = 'Modification not permitted. Either the comment has been deleted, or you do not have permissions to edit this comment.';
    public const COMMENT_DELETE_NOT_ALLOWED = 'Deletion of comments has been blocked by your administartor';
    public const MESSAGE_DELETE_NOT_ALLOWED = 'You do not have permissions to edit the comment record, or you have exceeded the permitted edit time window';

    // TypeAgnosticResourceController
    public const TYPE_MUST_BE_SPECIFIED = 'The "@type" must be specified for all models.';
    public const UPSERT_NOT_SUPPORTED = 'Upsert Operation for %s modules is not supported.';

    // Files Controller
    public const INVALID_FILE_NAME = 'Invalid file name specified';
    public const INSUFFICIENT_SPACE_FOR_PUBLISH = "ERROR: Not enough space available. Minimum free space required is %d mb and available space is %d mb in %s";

    public const TIM_QUERY_ROUTE_RESTRAINT = 'Ensure TIM SKU is enabled for this endpoint to work';

    public const IMPROPER_RELATION_DEFINATION = 'Correspondig reverse mapping for module does not exists';

    // QueryResourceController
    public const RECORD_NOT_EXISTS = 'Record with Provided UUID does not exists';

    // PeopleSubscriber
    public const INVALID_UUID_PROVIDED = 'Invalid UUID provided for %s';

    public const SME_IS_IN_USE = 'The Secure Message Exchange is currently being used for communication with %s agent(s) and, therefore, cannot be deleted. You must first use another Secure Message Exchange server for communication with these agents';
    public const FSR_CH_0000001 = "FSR_CH_0000001 : The \"%s\" field is required to have a value from the \"%s\" picklist. However, the provided value does not match any of the options listed in the specified picklist.";
    public const FSR_CH_0000002 = "FSR_CH_0000002 : FSR Type is not present in Context";
    public const FSR_CH_0000003 = "FSR_CH_0000003 : No attributes of picklist type is present in module %s.";
    public const FSR_CH_0000004 = "FSR_CH_0000004 : Attribute %s is not of type picklist";
    public const FSR_CH_0000011 = 'FSR_CH_0000011 : Nested documents for attribute "%s" are not allowed. Use IRIs instead.';
    public const FSR_CH_0000010 = 'FSR_CH_0000010 : Item not found for resource "%s" with id "%s".';
    public const FSR_CH_0000008 = 'FSR_CH_0000008 : Expected item to be an object or null.';
    public const FSR_CH_0000009 = 'FSR_CH_0000009 : Expected IRI or nested document for attribute "%s", "%s" given.';
    public const FSR_CH_0000006 = 'FSR_CH_0000006 : Invalid IRI "%s".';
    public const FSR_CH_0000007 = 'FSR_CH_0000007 : The injected serializer must be an instance of "%s".';
    public const FSR_CH_0000005 = 'FSR_CH_0000005 : Update is not allowed for this operation.';
    public const FSR_CH_0000012 = "FSR_CH_0000012 : No picklists in system with name as '%s'";
    public const FSR_CH_0000013 = "FSR_CH_0000013 : Picklist Item: %s not found";
    public const FSR_CH_0000014 = "FSR_CH_0000014 : The request is missing the inclusion of API token headers.";
    public const FSR_CH_0000015 = "FSR_CH_0000015 : API Key passed is invalid or expired.";

    public const FSR_CH_0000017 = "FSR_CH_0000017 : Attribute %s is not part of Module %s";
    public const FSR_CH_0000018 = "FSR_CH_0000018 : Record not created due to preprocessing rule '%s'.";
    public const FSR_CH_0000019 = "FSR_CH_0000019 : Rule will not be executed as '%s' Module is not trackable.";
    public const FSR_CH_0000020 = "FSR_CH_0000020 : Data & Rule attributes are mandatory.";
}

