<?php
/* Copyright start
  Copyright (C) 2008 - 2024 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\EventSubscriber;

use App\Entity\Actors\Actor;
use App\Entity\Actors\Avatar;
use Doctrine\ORM\EntityManagerInterface;
use ApiPlatform\Api\IriConverterInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

class AvatarListener
{
    public function __construct(
        protected ContainerInterface $container,
        protected IriConverterInterface $iriConverter,
        protected EntityManagerInterface $entityManager
    ) {
    }

    public function prePersist(Avatar $avatar)
    {
        $actorUuid = $avatar->getUuid();
        $entityRepo = $this->entityManager->getRepository(Actor::class);
        $actor = $entityRepo->findOneBy(["uuid" => $actorUuid]);
        if ($actor) {
            $avatarIri = $this->iriConverter->getIriFromResource($avatar);
            $actor->setAvatar($avatarIri);
            $this->entityManager->persist($actor);
            $this->entityManager->flush();
        }
    }
}
