<?php

declare(strict_types=1);

namespace App\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20231228122536 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'Migration for PreprocessingRules';
    }

    public function up(Schema $schema): void
    {
        // this up() migration is auto-generated, please modify it to your needs
        // Handle permissions for 'PreprocessingRules' module
        $fetchPreprocessingRulesModuleResults = $this->connection->fetchAllAssociative("SELECT uuid FROM modules WHERE type = 'preprocessing_rules'");
        $fetchFullAppPermissionsRoleResults = $this->connection->fetchAllAssociative("SELECT uuid FROM roles WHERE name = 'Full App Permissions'");
        if (count($fetchFullAppPermissionsRoleResults)) {
            $fullAppPermissionsRoleUuid = $fetchFullAppPermissionsRoleResults[0]['uuid'];
        }

        if(!$fetchPreprocessingRulesModuleResults) {
            $dateTimeNow = new \DateTime('NOW', new \DateTimeZone('UTC'));
            $dateTimeNow = $dateTimeNow->format('Y-m-d H:i:s');
            $this->addSql("INSERT INTO public.modules (uuid, createuser, modifyuser, type, name, system, icon, description, createdate, modifydate) VALUES ('faf57558-d881-4893-ace7-198f83da12cc', NULL, NULL, 'preprocessing_rules', 'Preprocessing Rules', true, NULL, 'Allows interaction with preprocessing rules.', '$dateTimeNow', '$dateTimeNow') on conflict do nothing;");
            $this->addSql("INSERT INTO module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('8cc2a42c-b971-432c-b0cf-1a9bb27ac5d4', 'faf57558-d881-4893-ace7-198f83da12cc', true, false, true, true, true) on conflict do nothing;");
            if ($fullAppPermissionsRoleUuid) {
                $this->addSql("INSERT INTO role_modulepermission (role_uuid, modulepermission_uuid) values ('$fullAppPermissionsRoleUuid', '8cc2a42c-b971-432c-b0cf-1a9bb27ac5d4') on conflict do nothing; ");
            }
        }

        // Handle 'Preprocessing Actions Type' picklist used in 'PreprocessingRules' module
        $fetchPreprocessingActionsTypePicklistResults = $this->connection->fetchAllAssociative("SELECT uuid FROM picklist_names WHERE name = 'Preprocessing Action Types'");
        if(!$fetchPreprocessingActionsTypePicklistResults) {
            $this->addSql("INSERT INTO public.picklist_names (uuid, name, system) VALUES ('86eed510-257d-4aa8-8c51-e05e96b5ac3d', 'Preprocessing Action Types', true) on conflict do nothing;");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname) VALUES ('e71346e9-408f-4989-8eef-fa170ca05515', 'Drop', 0, NULL, NULL, '86eed510-257d-4aa8-8c51-e05e96b5ac3d') on conflict do nothing;");
            $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, listname) VALUES ('8d091eb5-e1a3-469a-a2d0-9c50d1b96d9c', 'Update', 1, NULL, NULL, '86eed510-257d-4aa8-8c51-e05e96b5ac3d')on conflict do nothing;");
        }
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->addSql("DELETE FROM picklists WHERE listname='86eed510-257d-4aa8-8c51-e05e96b5ac3d';");
        $this->addSql("DELETE FROM picklist_names WHERE uuid='86eed510-257d-4aa8-8c51-e05e96b5ac3d';");
        $this->addSql("DELETE FROM module_permissions WHERE module_uuid='faf57558-d881-4893-ace7-198f83da12cc';");
        $this->addSql("DELETE FROM modules WHERE uuid='faf57558-d881-4893-ace7-198f83da12cc';");

    }
}
