<?php
/* Copyright start
  Copyright (C) 2008 - 2024 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Serializer\Normalizer;

use App\Entity\Actors\Actor;
use App\Entity\Actors\ApiKey;
use App\Entity\Custom\Person;
use App\Entity\Custom\Appliance;
use App\Entity\Authorization\Team;

final class TeamNormalizer extends EfficientItemNormalizer
{

    public function normalize($object, $format = null, array $context = [])
    {

        if (array_key_exists('object_class', $context) && (in_array($context['object_class'][0], [Actor::class, Person::class, Appliance::class, ApiKey::class]))) {
            return $this->iriConverter->getIriFromResource($object);
        }
        $context['ignore_depth'] = false;
        return parent::normalize($object, $format, $context);
    }

    public function supportsNormalization($data, $format = null, array $context = []): bool
    {
        return 'jsonld' === $format && ($data instanceof Team);
    }

    /**
     * {@inheritdoc}
     */
    public function supportsDenormalization($data, $type, $format = null, array $context = [])
    {
        return false;
    }
}
